VERSION 5.00
Begin VB.Form frmDateTime 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   0  'None
   ClientHeight    =   2340
   ClientLeft      =   3000
   ClientTop       =   4995
   ClientWidth     =   3390
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   FillColor       =   &H004E3E2E&
   BeginProperty Font 
      Name            =   "MS Serif"
      Size            =   12
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00816850&
   HasDC           =   0   'False
   Icon            =   "frmTime.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Moveable        =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   2340
   ScaleWidth      =   3390
   ShowInTaskbar   =   0   'False
   Begin VB.Timer tmrTime 
      Interval        =   1000
      Left            =   2925
      Top             =   1875
   End
   Begin VB.Label lblClock 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H00000000&
      ForeColor       =   &H00816850&
      Height          =   1410
      Left            =   255
      TabIndex        =   0
      Top             =   180
      UseMnemonic     =   0   'False
      Width           =   2505
   End
End
Attribute VB_Name = "frmDateTime"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'  Copyright (C) 1998-99 Chris Rempel
'                    aka jugg
'
'  This program is free software; you can redistribute it and/or
'  modify it under the terms of the GNU General Public License
'  as published by the Free Software Foundation; either version 2
'  of the License, or (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
Private Sub Form_Click()
    lblClock_Click
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    lblClock_MouseDown Button, Shift, x, Y
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    lblClock_MouseMove Button, Shift, x, Y
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)
    lblClock_MouseUp Button, Shift, x, Y
End Sub

Private Sub Form_Load()
    SetWindowLong Me.hwnd, GWL_EXSTYLE, WS_EX_TOOLWINDOW 'hide from the taskbar
    DTVersionInfo = "v1.00"
    DTExePath = CurDir
    
    If Right(DTExePath, 1) <> "\" Then DTExePath = DTExePath & "\"
    DTiniPathFile = DTExePath & "datetime.ini" 'ini file to look in to determine which ini file to find settings in.
    
    Dim n, a$
    a$ = Space$(128)
    n = GetPrivateProfileString("DateTime", "iniPath", DTExePath, a$, 128, DTiniPathFile)
    DTiniPath = Left$(a$, n)
    n = GetPrivateProfileString("DateTime", "iniFile", "settings.ini", a$, 128, DTiniPathFile)
    DTiniFile = Left$(a$, n)
    
    Load frmSetup
    Load frmNTPSetup
    mouseActive = False
    mouseMoved = False
    moveOnce = False
    isSettingColor = False
    loadSettings
End Sub

Public Sub loadSettings()
    DTLayOut
With frmSetup
    If .mnu24Hour.Checked = True Then tempTime = time24h Else tempTime = time12h
    If .mnuAltDate.Checked = True Then tempDate = altDate Else tempDate = usDate
    If .mnuiTime.Checked = True Then
        .mnu24Hour.Enabled = False
        .mnu12Hour.Enabled = False
        .mnuUSDate.Enabled = False
        .mnuAltDate.Enabled = False
    Else
        .mnu24Hour.Enabled = True
        .mnu12Hour.Enabled = True
        .mnuUSDate.Enabled = True
        .mnuAltDate.Enabled = True
    End If
'Cosmetics
    lblClock.Alignment = .lblTextAlign.Alignment
    DTOrder = .lblDTOrder.Tag
    lblClock.BackColor = .lblBGColor.BackColor
    Me.BackColor = .lblBdrColor.BackColor
    lblClock.ForeColor = .lblTextColor.BackColor
    lblClock.FontName = .lblTextFont.FontName
    lblClock.FontBold = .lblTextFont.FontBold
    lblClock.FontItalic = .lblTextFont.FontItalic
    lblClock.FontSize = .lblTextFont.FontSize
'Settings
    If .chkDateDisplay = 1 And .chkTimeDisplay = 0 Then
        IsDateTime = False
    ElseIf .chkDateDisplay = 0 And .chkTimeDisplay = 1 Then
        IsDateTime = True
    ElseIf .chkDateDisplay = 0 And .chkTimeDisplay = 0 Then
        MsgBox "Either Date or the Time must be Displayed!", vbCritical, "Error..."
        If bothDT = True Then
            .chkDateDisplay = 1
            .chkTimeDisplay = 1
        ElseIf IsDateTime = True Then
            .chkDateDisplay = 0
            .chkTimeDisplay = 1
        Else
            .chkDateDisplay = 1
            .chkTimeDisplay = 0
        End If
    End If
    If .chkDateDisplay = 1 And .chkTimeDisplay = 1 Then bothDT = True Else bothDT = False
    If .chkClkAutoSize = 1 Then autoResize = True Else autoResize = False
    If .chkClkDragging = 1 Then timeDrag = True Else timeDrag = False
    If Val(.txtBMTTime) < -12 Or Val(.txtBMTTime) > 12 Then
        MsgBox "Invalid BMT Time Setting!", vbCritical, "Error..."
        .txtBMTTime.Text = BMTTime
    Else: BMTTime = Val(.txtBMTTime)
    End If
    updateClock
    reSizeForm
'Background Image
    If .imgBGImage.Tag = "" Or autoResize = True Then
        lblClock.BackStyle = 1
        Me.Cls
    Else
        lblClock.BackStyle = 0
        Me.Cls
        Me.PaintPicture LoadPicture(.imgBGImage.Tag), 0, 0, Me.ScaleWidth, Me.ScaleHeight
    End If
    If .mnuAlwaysOnTop.Checked = True And .mnuAlwaysOnBottom.Checked = False Then
        SetWindowPos frmDateTime.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
    ElseIf .mnuAlwaysOnBottom.Checked = True And .mnuAlwaysOnTop.Checked = False Then
        If FindWindow("DesktopBackgroundClass", "") Then SetWindowPos frmDateTime.hwnd, 200, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE Else SetWindowPos frmDateTime.hwnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
    Else
        SetWindowPos frmDateTime.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
    End If
End With
End Sub

Public Sub reSizeForm()
On Local Error GoTo badDimensions
With frmSetup
    If Val(.txtClkBorder.Text) < 0 Then GoTo badBorder
    If (Val(.txtClkBorder.Text) * 2 >= Val(.txtClkWidth.Text)) Or (Val(.txtClkBorder.Text) * 2 >= Val(.txtClkHeight.Text)) Then GoTo badDimensions
    If autoResize = False Then
        lblClock.AutoSize = False
        lblClock.Width = (Val(.txtClkWidth.Text) - Val(.txtClkBorder.Text) * 2) * Screen.TwipsPerPixelX
        lblClock.Height = (Val(.txtClkHeight.Text) - Val(.txtClkBorder.Text) * 2) * Screen.TwipsPerPixelY
    Else
        lblClock.AutoSize = True
        .txtClkWidth.Text = Val(lblClock.Width / Screen.TwipsPerPixelX) + Val(.txtClkBorder.Text) * 2
        .txtClkHeight.Text = Val(lblClock.Height / Screen.TwipsPerPixelY) + Val(.txtClkBorder.Text) * 2
        lblClock.AutoSize = False
    End If
    Me.Width = lblClock.Width + Val(.txtClkBorder.Text) * 2 * Screen.TwipsPerPixelX
    Me.Height = lblClock.Height + Val(.txtClkBorder.Text) * 2 * Screen.TwipsPerPixelY
    Me.Left = Val(.txtClkXPos.Text) * Screen.TwipsPerPixelX
    Me.Top = Val(.txtClkYPos.Text) * Screen.TwipsPerPixelY
    lblClock.Left = Me.ScaleLeft + Val(.txtClkBorder.Text) * Screen.TwipsPerPixelX
    lblClock.Top = Me.ScaleTop + Val(.txtClkBorder.Text) * Screen.TwipsPerPixelY
    If Me.Top + Me.Height > Screen.Height Then Me.Top = Screen.Height - Me.Height
    If Me.Top < 0 Then Me.Top = 0
    If Me.Left + Me.Width > Screen.Width Then Me.Left = Screen.Width - Me.Width
    If Me.Left < 0 Then Me.Left = 0
    .txtClkXPos = Me.Left / Screen.TwipsPerPixelX
    .txtClkYPos = Me.Top / Screen.TwipsPerPixelY
End With
Exit Sub
badBorder:
    MsgBox "Invalid Border size! Must be a positive Integer!", vbCritical, "Error..."
    GoTo fixSettings
badDimensions:
    MsgBox "Invalid Clock width and/ or height!", vbCritical, "Error..."
fixSettings:
    frmSetup.txtClkBorder.Text = (Val((Me.Width - lblClock.Width) / 2) / Screen.TwipsPerPixelX)
    frmSetup.txtClkWidth.Text = Val(lblClock.Width / Screen.TwipsPerPixelX) + Val(frmSetup.txtClkBorder.Text) * 2
    frmSetup.txtClkHeight.Text = Val(lblClock.Height / Screen.TwipsPerPixelY) + Val(frmSetup.txtClkBorder.Text) * 2
End Sub

Private Sub DTLayOut()
    setSecond = "ss"
    setMinute = "mm"
    setHour = "hh"
    timeSep1 = ":"
    timeSep2 = ":"
With frmSetup
    If .lblDateLS(0).Tag = "1" Then
        dateSep1 = ", "
        longDay = "dddd"
        setDay = "dd"
    Else
        dateSep1 = ""
        longDay = ""
        setDay = "dd"
    End If
    If .lblDateLS(1).Tag = "1" Then
        dateSep2 = " "
        dateSep3 = ", "
        setMonth = "mmmm"
    Else
        dateSep2 = "."
        dateSep3 = "."
        setMonth = "mm"
    End If
    If .lblDateLS(2).Tag = "1" Then setYear = "yyyy" Else setYear = "yy"
    If .chkDateYear.Value = 0 Then
        setYear = ""
        dateSep3 = ""
    End If
    If .chkTimeHours.Value = 0 Then
        setHour = ""
        timeSep1 = ""
    End If
    If .chkTimeMinutes.Value = 0 Then
        setMinute = ""
        timeSep2 = ""
    End If
    If .chkTimeSeconds.Value = 0 Then
        setSecond = ""
        timeSep2 = ""
    End If
    If .chkTimeMinutes.Value = 0 And .chkTimeSeconds.Value = 0 Then timeSep1 = ""
End With
    time24h = setHour & timeSep1 & setMinute & timeSep2 & setSecond
    time12h = setHour & timeSep1 & setMinute & timeSep2 & setSecond & " am/pm"
    altDate = longDay & dateSep1 & setDay & dateSep2 & setMonth & dateSep3 & setYear
    usDate = longDay & dateSep1 & setMonth & dateSep2 & setDay & dateSep3 & setYear
End Sub

Private Sub getDaysInMonth(x As Integer, Y As Integer)
    Dim oneMonth, twoMonth As String
    Dim tmp, tmp2, tmpyr, tmpyr2
    tmpyr = Format(Date, "yy")
    tmpyr2 = Format(Date, "yy")
    tmp = Month(Date) - x
    If tmp = 0 Then
        tmp = 12
        tmpyr = Format(Date, "yy") - 1
        If tmpyr = -1 Then tmpyr = 99
    End If
    tmp2 = Month(Date) + Y
    If tmp2 = 13 Then
        tmp2 = 1
        tmpyr2 = Format(Date, "yy") + 1
        If tmpyr2 = 100 Then tmpyr2 = 0
    End If
    oneMonth = Format(Date, tmp & "/1/" & tmpyr)
    twoMonth = Format(Date, tmp2 & "/1/" & tmpyr2)
    numOfDays = DateDiff("d", oneMonth, twoMonth)
End Sub

Private Sub getIdate()
    Dim iDay, iMonth, iYear
    iMonth = Format(Date, "mm")
    iYear = Format(Date, "yy")
    If BMTTime >= 0 And Hour(Time) - BMTTime < 0 Then
        iDay = Format(Date, "dd") - 1
        If iDay = 0 Then
            getDaysInMonth 1, 0
            iDay = numOfDays
            iMonth = Format(Date, "mm") - 1
            If iMonth = 0 Then
                iMonth = 12
                iYear = Format(Date, "yy") - 1
                If iYear = -1 Then iYear = 99
            End If
        End If
    ElseIf BMTTime < 0 And Hour(Time) - BMTTime > 23 Then
        iDay = Format(Date, "dd") + 1
        getDaysInMonth 0, 1
        If iDay > numOfDays Then
            iDay = 1
            iMonth = Format(Date, "mm") + 1
            If iMonth = 13 Then
                iMonth = 1
                iYear = Format(Date, "yy") + 1
                If iYear = 100 Then iYear = 0
            End If
        End If
    Else
        iDate = Format(Date, "dd.mm.yy")
        Exit Sub
    End If
If Len(iDay) = 1 Then iDay = "0" & iDay
If Len(iMonth) = 1 Then iMonth = "0" & iMonth
If Len(iYear) = 1 Then iYear = "0" & iYear
iDate = iDay & "." & iMonth & "." & iYear
End Sub

Private Sub getItime()
    Dim temp, intTime, decTime, i
    temp = (Hour(Time) - BMTTime)
    If BMTTime >= 0 And temp < 0 Then
        temp = (temp + 24) * 3600
    ElseIf BMTTime <= 0 And temp > 23 Then
        temp = (temp - 24) * 3600
    Else: temp = temp * 3600
    End If
    iTime = temp
    temp = Minute(Format(Time, "hh:mm:ss")) * 60
    iTime = iTime + temp
    temp = Second(Format(Time, "hh:mm:ss"))
    iTime = (iTime + temp) / 86.4
    intTime = Int(iTime)
    For i = 1 To (3 - Len(intTime)) Step 1
        intTime = "0" & intTime
    Next i
    decTime = Round((iTime - Int(iTime)), 5)
    If Len(decTime) > 3 Then
        decTime = Right(decTime, (Len(decTime) - 2))
        decTime = Left(decTime, 2)
    ElseIf Len(decTime) = 3 Then
        decTime = Right(decTime, 1) & "0"
    Else
        For i = 1 To (2 - Len(decTime)) Step 1
            decTime = decTime & "0"
        Next i
    End If
    iTime = intTime & "." & decTime
    If setSecond = "" Then iTime = intTime
End Sub

Private Sub getDTOrder()
With frmSetup
    If .mnuiTime.Checked = False Then
        Select Case (DTOrder)
            Case "0"
                lblClock.Caption = Format(Date, tempDate) & " " & Format(Time, tempTime)
            Case "1"
                lblClock.Caption = Format(Date, tempDate) & Chr(13) + Chr(10) & Format(Time, tempTime)
            Case "2"
                lblClock.Caption = Format(Time, tempTime) & " " & Format(Date, tempDate)
            Case "3"
                lblClock.Caption = Format(Time, tempTime) & Chr(13) + Chr(10) & Format(Date, tempDate)
        End Select
    Else
        Select Case (DTOrder)
            Case "0"
                lblClock.Caption = iDate & " " & "@" & iTime
            Case "1"
                lblClock.Caption = iDate & Chr(13) + Chr(10) & "@" & iTime
            Case "2"
                lblClock.Caption = "@" & iTime & " " & iDate
            Case "3"
                lblClock.Caption = "@" & iTime & Chr(13) + Chr(10) & iDate
        End Select
    End If
End With
End Sub

Public Sub updateClock()
    Dim tmp, tmp2 As String
    With frmSetup
    If .mnuiTime.Checked = False Then
        If bothDT = True Then
            getDTOrder
        Else
            If IsDateTime = False Then lblClock.Caption = Format(Date, tempDate) Else lblClock.Caption = Format(Time, tempTime)
        End If
    ElseIf .mnuiTime.Checked = True Then
        If bothDT = True Then
            getIdate
            getItime
            getDTOrder
        Else
            If IsDateTime = False Then
                getIdate
                lblClock.Caption = iDate
            Else
                getItime
                lblClock.Caption = "@" & iTime
            End If
        End If
    End If
End With
End Sub

Private Sub lblClock_Click()
    If mouseButton = 2 Then PopupMenu frmSetup.mnuzzzOptions
    If mouseButton <> 2 And mouseMoved = False Then
        If bothDT = False Then
            If IsDateTime = True Then
                frmSetup.chkTimeDisplay = 0
                frmSetup.chkDateDisplay = 1
                IsDateTime = False
            Else
                frmSetup.chkTimeDisplay = 1
                frmSetup.chkDateDisplay = 0
                IsDateTime = True
            End If
            updateClock
            If autoResize = True Then reSizeForm
'        Else
'         With frmSetup
'            Select Case (.lblDTOrder.Tag)
'                Case "0"
'                    .lblDTOrder.Caption = "Date" & Chr(13) + Chr(10) & "Time"
'                    .lblDTOrder.Tag = "1"
'                Case "1"
'                    .lblDTOrder.Caption = "Time" & "     " & "Date"
'                    .lblDTOrder.Tag = "2"
'                Case "2"
'                    .lblDTOrder.Caption = "Time" & Chr(13) + Chr(10) & "Date"
'                    .lblDTOrder.Tag = "3"
'                Case "3"
'                    .lblDTOrder.Caption = "Date" & "     " & "Time"
'                    .lblDTOrder.Tag = "0"
'            End Select
'         End With
'            updateClock
'            If autoResize = True Then reSizeForm
        End If
    End If
    mouseMoved = False
End Sub

Private Sub lblClock_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    mouseButton = Button
    If Button <> 2 Then
        moveOnce = True
        mouseActive = True
        moveY = Y + Me.Top
        moveX = x + Me.Left
        mouseY = Y
        mouseX = x
    End If
    If frmSetup.mnuAlwaysOnTop.Checked = False And frmSetup.mnuAlwaysOnBottom.Checked = False Then SetWindowPos frmDateTime.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
End Sub

Private Sub lblClock_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    If mouseActive = True And timeDrag = True Then
        If frmSetup.mnuAlwaysOnBottom.Checked = True And moveOnce = True Then SetWindowPos frmDateTime.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
        Me.Top = Y - mouseY + Me.Top
        Me.Left = x - mouseX + Me.Left
        moveOnce = False
    End If
End Sub

Private Sub lblClock_MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)
    If Y + Me.Top = moveY And x + Me.Left = moveX Then mouseMoved = False Else mouseMoved = True
    mouseActive = False
    If Me.Top + Me.Height > Screen.Height Then Me.Top = Screen.Height - Me.Height
    If Me.Top < 0 Then Me.Top = 0
    If Me.Left + Me.Width > Screen.Width Then Me.Left = Screen.Width - Me.Width
    If Me.Left < 0 Then Me.Left = 0
    frmSetup.txtClkXPos = Me.Left / Screen.TwipsPerPixelX
    frmSetup.txtClkYPos = Me.Top / Screen.TwipsPerPixelY
    If frmSetup.mnuAlwaysOnBottom.Checked = True Then
        If FindWindow("DesktopBackgroundClass", "") Then SetWindowPos frmDateTime.hwnd, 200, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE Else SetWindowPos frmDateTime.hwnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
    End If
    If frmSetup.mnuAlwaysOnTop.Checked = False And frmSetup.mnuAlwaysOnBottom.Checked = False Then SetWindowPos frmDateTime.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
End Sub

Private Sub tmrTime_Timer()
    If IsDateTime = True Or bothDT = True Then updateClock
End Sub
